
%define svn 20100511
%define translations kivio-translations-%{svn}

Name:           koffice-kivio
Epoch:          3
Version:        1.6.3
Release:        32.trinity.%{svn}svn%{?dist}
Summary:        A flowcharting application

Group:          Applications/Productivity
License:        GPLv2+
URL:            http://www.koffice.org/
# svn://anonsvn.kde.org/home/kde/branches/trinity/applications/koffice/
# SVNDATE=20100511
# svn export \
# svn://anonsvn.kde.org/home/kde/branches/trinity/applications/koffice/ \
# koffice-trinity-${SVNDATE}
# tar cjf koffice-trinity-${SVNDATE}.tar.bz2 koffice-trinity-${SVNDATE}
Source0:        koffice-trinity-%{svn}.tar.bz2
# collected from svn://anonsvn.kde.org/home/kde/branches/stable/l10n/
# ./create_tarball_kivio.rb -n -a kivio
Source1:        %{translations}.tar.bz2
# script used to fetch translations (patched extragear-tarball script)
Source100:      create_tarball_kivio.rb
# config file for the above script
Source101:      config.ini
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# disable some nested subdirectories which are not needed for Kivio
Patch0:         koffice-trinity-20100511-only-kivio.patch
# rename koffice.po and kofficefilters.po because they conflict with KOffice 2
Patch1:         koffice-trinity-20100511-rename-po.patch
# fix kivio.desktop to validate
Patch2:         koffice-trinity-20100511-kivio-desktop.patch

# build the translations standalone, using the KDE 4 CMake framework
Patch50:        kivio-translations-20100511-standalone.patch

BuildRequires:  kdelibs3-devel
# See http://bugzilla.redhat.com/244091
%global kdelibs3_ver %((kde-config --version 2>/dev/null || echo KDE 3.5.10) | grep '^KDE' | cut -d' ' -f2 | cut -d'-' -f1)
BuildRequires:  automake libtool
BuildRequires:  freetype-devel
BuildRequires:  fontconfig-devel
BuildRequires:  GraphicsMagick-devel
BuildRequires:  libart_lgpl-devel
BuildRequires:  libpng-devel
BuildRequires:  libtiff-devel
BuildRequires:  libjpeg-devel
BuildRequires:  bzip2-devel
BuildRequires:  zlib-devel
BuildRequires:  openssl-devel
BuildRequires:  gettext-devel
BuildRequires:  desktop-file-utils
BuildRequires:  perl

# for translations:
BuildRequires:  cmake kdelibs4-devel gettext kde-filesystem

# directory ownership
Requires:       hicolor-icon-theme

Provides:       kivio = %{version}-%{release}
Obsoletes:      kivio < %{version}-%{release}

Requires:       %{name}-libs = %{version}-%{release}

Conflicts:      koffice-core < 3:1.7

# koffice-langpack-2:2.1.91-1 included translated Kivio documentation, so force
# upgrading to 2:2.1.91-2 which fixes that to prevent file conflicts
Conflicts:      koffice-langpack < 2:2.1.91-2

%description
%{summary}.

%package libs
Epoch:          0
Summary:        Runtime libraries for %{name}
Group:          System Environment/Libraries
Conflicts:      koffice-libs < 3:1.7
Requires:       kdelibs3 >= %{kdelibs3_ver}
License:        LGPLv2+
%description libs
%{summary}.


%prep
%setup -q -n koffice-trinity-%{svn} -a 1
%patch0 -p1 -b .only-kivio
%patch1 -p1 -b .rename-po
%patch2 -p1 -b .kivio-desktop

make -f admin/Makefile.common

pushd %{translations}
%patch50 -p1 -b .standalone
# rename koffice.po and kofficefilters.po because they conflict with KOffice 2
for i in po/* ; do
  if [ -f "$i/koffice.po" ] ; then
    mv -f "$i/koffice.po" "$i/koffice1.po"
  fi
  if [ -f "$i/kofficefilters.po" ] ; then
    mv -f "$i/kofficefilters.po" "$i/koffice1filters.po"
  fi
done
popd

# rename the KOffice README which conflicts with the Kivio one
mv README README.koffice


%build
unset QTDIR || : ; . /etc/profile.d/qt.sh

# build only the subdirectories needed for Kivio
echo "pics servicetypes lib kivio filters doc" >inst-apps

%configure \
  --disable-rpath --disable-dependency-tracking \
  --enable-new-ldflags \
  --disable-debug --disable-warnings \
  --with-pic --enable-shared --disable-static \
  --with-extra-libs=%{_libdir} \
  --disable-final

# workaround various libtool suckage
cp -f %{_bindir}/libtool libtool
sed -i 's|^build_old_libs=yes|build_old_libs=no|g' libtool
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

make %{?_smp_mflags}

pushd %{translations}
%cmake_kde4 .
make %{?_smp_mflags}
popd


%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

pushd %{translations}
make install/fast DESTDIR=%{buildroot}
popd

# Replace absolute symlinks with relative ones
pushd %{buildroot}%{_docdir}/HTML
for lang in *; do
  if [ -d $lang ]; then
    pushd $lang
    for i in */*; do
      [ -d $i -a -L $i/common ] && rm -f $i/common && ln -sf ../../common $i/common
    done
    popd
  fi
done
popd

desktop-file-validate %{buildroot}%{_datadir}/applications/kde/kivio.desktop

## unpackaged files
# libtool archives
rm -f %{buildroot}%{_libdir}/lib*.la
# devel headers
rm -rf %{buildroot}%{_includedir}
# devel symlinks
rm -f %{buildroot}%{_libdir}/libkiviocommon.so
rm -f %{buildroot}%{_libdir}/libko*.so
rm -f %{buildroot}%{_libdir}/libkstore.so
rm -f %{buildroot}%{_libdir}/libkwmf.so
# hyphenation dictionaries (Kivio doesn't support hyphenation)
rm -rf %{buildroot}%{_datadir}/apps/koffice/hyphdicts
# irrelevant general KOffice documentation files
rm -rf %{buildroot}%{_docdir}/HTML/en/koffice
rm -rf %{buildroot}%{_docdir}/HTML/en/koffice-apidocs

%find_lang kivio --with-kde
%find_lang koffice1
cat koffice1.lang >>kivio.lang
rm -f koffice1.lang
%find_lang koffice1filters
cat koffice1filters.lang >>kivio.lang
rm -f koffice1filters.lang

# dedupe translations, as find_lang queries both kde-config and kde4-config for
# the same documentation directory and takes files from both
sort -u kivio.lang >kivio-unique.lang
mv -f kivio-unique.lang kivio.lang


%clean
rm -rf %{buildroot}

%post
touch --no-create %{_datadir}/icons/hicolor &> /dev/null || :

%postun
if [ $1 -eq 0 ]; then
  gtk-update-icon-cache %{_datadir}/icons/hicolor &> /dev/null || :
  update-desktop-database -q &> /dev/null ||:
fi

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &> /dev/null || :
update-desktop-database -q &> /dev/null ||:

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files -f kivio.lang
%defattr(-,root,root,-)
%doc kivio/AUTHORS kivio/LICENSE kivio/README README.koffice
%doc kivio/CHANGELOG kivio/CHANGES
%{_bindir}/kivio
%{_libdir}/libkdeinit_kivio.so
%{_libdir}/kde3/*
%{_datadir}/apps/kivio/
%{_datadir}/apps/koffice/
%{_datadir}/apps/kofficewidgets/
%{_datadir}/config.kcfg/kivio.kcfg
%{_datadir}/services/*.desktop
%{_datadir}/servicetypes/*.desktop
%{_datadir}/applications/kde/kivio.desktop
%{_datadir}/icons/hicolor/*/apps/kivio.png

%files libs
%defattr(-,root,root,-)
%doc COPYING.LIB
%{_libdir}/lib*.so.*


%changelog
* Tue May 18 2010 Kevin Kofler <Kevin@tigcc.ticalc.org>
- 3:1.6.3-32.trinity.20100511
- document tarball origin as requested in the review
- Conflicts: koffice-langpack < 2:2.1.91-2, documentation files conflict

* Sat May 15 2010 Kevin Kofler <Kevin@tigcc.ticalc.org>
- 3:1.6.3-31.trinity.20100511
- ship /usr/share/apps/koffice/koffice_shell.rc, Kivio needs it

* Thu May 13 2010 Kevin Kofler <Kevin@tigcc.ticalc.org>
- 3:1.6.3-30.trinity.20100511
- split out kivio from the koffice 1.6 packaging
